# Animated Julia set, known as
# 3D Julia Morpher
# Generating sequence:
#  Z(0)=(X,Y)
#  C=(f(t),g(t))
#  Z(n+1)=sqr(Z(n))+C

# Values
pmin= -2; pmax=2;
qmin= -2; qmax=2;
xmid=0; ymid=0; zmid=0; scale =4;
tmax=48;

# Precalculations
a=sin(t>>4);
cre=a*cos(t>>4);
cim=a*a;

# The function itself

main

re=x;
im=y;
re2 = re*re;
im2 = im*im;
while (re2+im2 < 4 && z < 1.25)
  {
    im = re * im << 1 + cim;
    re = re2 - im2 + cre;
    re2 = re * re;
    im2 = im * im;
    z += 0.125
  }