.386
locals
jumps
.model flat,STDCALL

extrn GetModuleHandleA:Proc
extrn MessageBoxA:Proc
extrn ExitProcess:Proc
extrn CreateWindowExA:Proc
extrn RegisterClassA:Proc
extrn GetMessageA:Proc
extrn DispatchMessageA:Proc
extrn TranslateMessage:Proc
extrn LoadCursorA:Proc
extrn LoadIconA:Proc
extrn PostQuitMessage:Proc
extrn DefWindowProcA:Proc
extrn GetWindowTextA:Proc
extrn GetWindowTextLengthA:Proc

CS_VREDRAW      EQU 0001h    
CS_HREDRAW      EQU 0002h
CS_GLOBALCLASS  EQU 4000h    ; Global window class

COLOR_WINDOW    EQU 5

CW_USEDEFAULT   EQU 8000h

WS_OVERLAPPED   EQU 000000000h
WS_MAXIMIZEBOX  EQU 000010000h
WS_MINIMIZEBOX  EQU 000020000h
WS_THICKFRAME   EQU 000040000h
WS_SYSMENU      EQU 000080000h
WS_DLGFRAME     EQU 000400000h
WS_BORDER       EQU 000800000h
WS_CAPTION      EQU 000C00000h     ; WS_BORDER | WS_DLGFRAME
WS_VISIBLE      EQU 010000000h
WS_CHILD        EQU 040000000h

BS_DEFPUSHBUTTON EQU 0001h

WM_DESTROY      EQU 0002h
WM_COMMAND      EQU 0111h
WM_LBUTTONDOWN  EQU 0201h

WNDCLASS struc
        clsStyle          dd ?   ; class style
        clsLpfnWndProc    dd ?
        clsCbClsExtra     dd ?
        clsCbWndExtra     dd ?
        clsHInstance      dd ?   ; instance handle
        clsHIcon          dd ?   ; class icon handle
        clsHCursor        dd ?   ; class cursor handle
        clsHbrBackground  dd ?   ; class background brush
        clsLpszMenuName   dd ?   ; menu name
        clsLpszClassName  dd ?   ; far ptr to class name
WNDCLASS ends

POINT   struc
    ptX             dd ?
    ptY             dd ?
POINT   ends

MSGSTRUCT struc
    msHWND          dd ?
    msMESSAGE       dd ?
    msWPARAM        dd ?
    msLPARAM        dd ?
    msTIME          dd ?
    msPT            POINT <?>
MSGSTRUCT ends

.data

wc              WNDCLASS <?>
msg             MSGSTRUCT <?>

AppHWnd         dd 0
NewHWnd         dd 0
EditHWnd        dd 0
ButtonHWnd      dd 0

WindowCaption   db "Hello again",0
WndClassName    db "ASMClass",0

EditClass       db "Edit",0

ButtonCaption   db "Go !",0
ButtonClass     db "Button",0

MsgBoxCaption     db "Lesson 3",0
MsgBoxContent     db "Hello "
MsgBoxContentbis  db 23 dup (0)
defaultcomplement db "Myself !",0
edittextlength    dd 0

MsgBoxCaption2  db "Stop touching me !!",0
MsgBoxContent2  db "Enter your name and push the Go button !",0

.code

Start:
        push    0h
        call    GetModuleHandleA
        mov     [AppHWnd],eax

        mov     [wc.clsStyle], CS_HREDRAW + CS_VREDRAW + CS_GLOBALCLASS
        mov     [wc.clsLpfnWndProc], offset WndProc
        mov     [wc.clsCbClsExtra], 0
        mov     [wc.clsCbWndExtra], 0
        mov     eax, [AppHWnd]
        mov     [wc.clsHInstance], eax
        push    32516
        push    0
        call    LoadIconA
        mov     [wc.clsHIcon], eax
        push    32512
        push    0
        call    LoadCursorA
        mov     [wc.clsHCursor], eax
        mov     [wc.clsHbrBackground], COLOR_WINDOW + 1
        mov     dword ptr [wc.clsLpszMenuName], 0
        mov     dword ptr [wc.clsLpszClassName], offset WndClassName
        push    offset wc
        call    RegisterClassA

        push    0                      ; lpParam
        push    [AppHWnd]              ; hInstance
        push    0                      ; menu
        push    0                      ; parent hwnd
        push    80                     ; height
        push    178                    ; width
        push    CW_USEDEFAULT          ; y
        push    CW_USEDEFAULT          ; x
        push    WS_OVERLAPPED OR WS_DLGFRAME OR WS_SYSMENU OR WS_MINIMIZEBOX OR WS_MAXIMIZEBOX OR WS_VISIBLE; Style
        push    offset WindowCaption   ; Title string
        push    offset WndClassName    ; Class name
        push    0                      ; extra style
        call    CreateWindowExA
        mov     [NewHWnd], eax

        push    0                      ; lpParam
        push    [AppHWnd]              ; hInstance
        push    10h                    ; ID of the edit box
        push    [NewHWnd]              ; parent hwnd
        push    18                     ; height
        push    160                    ; width
        push    5                      ; y
        push    5                      ; x
        push    WS_BORDER OR WS_VISIBLE OR WS_CHILD; Style
        push    0                      ; Title string
        push    offset EditClass       ; Class name
        push    0                      ; extra style
        call    CreateWindowExA
        mov     [EditHWnd], eax

        push    0                      ; lpParam
        push    [AppHWnd]              ; hInstance
        push    20h                    ; ID of the button
        push    [NewHWnd]              ; parent hwnd
        push    20                     ; height
        push    46                     ; width
        push    25                     ; y
        push    62                     ; x
        push    WS_BORDER OR WS_VISIBLE OR WS_CHILD OR BS_DEFPUSHBUTTON; Style
        push    offset ButtonCaption   ; Title string
        push    offset ButtonClass     ; Class name
        push    0                      ; extra style
        call    CreateWindowExA
        mov     [ButtonHWnd], eax

msg_loop:
        push    0
        push    0
        push    0
        push    offset msg
        call    GetMessageA

        cmp     ax, 0
        je      end_loop

        push    offset msg
        call    TranslateMessage

        push    offset msg
        call    DispatchMessageA

        jmp     msg_loop

end_loop:
        push    0h
        call    ExitProcess


WndProc proc uses ebx edi esi, hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
        cmp     [wmsg], WM_COMMAND
        je      wmcommand
        cmp     [wmsg], WM_DESTROY
        je      wmdestroy
        cmp     [wmsg], WM_LBUTTONDOWN
        je      wmlbuttondown
        push    [lparam]
        push    [wparam]
        push    [wmsg]
        push    [hwnd]
        call    DefWindowProcA
        ret
wmcommand:
        cmp     [wparam],20h    ; Go pushed ?
        jne     nogo
        push    [EditHWnd]
        call    GetWindowTextLengthA
        mov     [edittextlength],eax
        mov     esi,eax
        cmp     esi,0
        mov     edi, offset MsgBoxContentbis
        jne     Morethanzero
        mov     esi, offset defaultcomplement
        mov     ecx,2
        cli
        rep     movsd
        jmp     displaymsgbox
Morethanzero:
        cmp     esi,19
        jna     Lessthannineteen
        mov     esi, offset defaultcomplement
        mov     ecx,2
        cli
        rep     movsd
        jmp     displaymsgbox
Lessthannineteen:
        inc     esi
        push    esi
        push    offset MsgBoxContentbis
        push    [EditHWnd]
        call    GetWindowTextA
        add     edi,[edittextlength]
        mov     eax,"! "
        mov     [edi],eax
displaymsgbox:
        push    30h
        push    offset MsgBoxCaption
        push    offset MsgBoxContent
        push    [NewHWnd]
        call    MessageBoxA
nogo:
        xor     eax,eax
        ret
wmdestroy:
        push    0
        call    PostQuitMessage
        mov     eax, 0
        ret
wmlbuttondown:
        push    20h
        push    offset MsgBoxCaption2
        push    offset MsgBoxContent2
        push    [NewHWnd]
        call    MessageBoxA
        xor     eax,eax
        ret

WndProc          endp

End Start
