.386
locals
jumps
.model flat,STDCALL

extrn GetModuleHandleA:Proc
extrn MessageBoxA:Proc
extrn ExitProcess:Proc
extrn CreateWindowExA:Proc
extrn RegisterClassA:Proc
extrn GetMessageA:Proc
extrn DispatchMessageA:Proc
extrn TranslateMessage:Proc
extrn LoadCursorA:Proc
extrn LoadIconA:Proc
extrn PostQuitMessage:Proc
extrn DefWindowProcA:Proc
extrn BeginPaint:Proc
extrn EndPaint:Proc
extrn CreateFileA:Proc
extrn ReadFile:Proc
extrn GlobalAlloc:Proc
extrn GlobalFree:Proc
extrn SetFilePointer:Proc
extrn GetDC:Proc
extrn ReleaseDC:Proc
extrn CreateDIBitmap:Proc
extrn BitBlt:Proc
extrn CreateCompatibleDC:Proc
extrn CloseHandle:Proc
extrn SelectObject:Proc
extrn GetOpenFileNameA:Proc
extrn RedrawWindow:Proc

CS_VREDRAW      EQU 0001h    
CS_HREDRAW      EQU 0002h
CS_GLOBALCLASS  EQU 4000h    ; Global window class

COLOR_WINDOW    EQU 5

CW_USEDEFAULT   EQU 8000h

WS_OVERLAPPED   EQU 000000000h
WS_MAXIMIZEBOX  EQU 000010000h
WS_MINIMIZEBOX  EQU 000020000h
WS_THICKFRAME   EQU 000040000h
WS_SYSMENU      EQU 000080000h
WS_DLGFRAME     EQU 000400000h
WS_BORDER       EQU 000800000h
WS_CAPTION      EQU 000C00000h     ; WS_BORDER | WS_DLGFRAME
WS_VISIBLE      EQU 010000000h

WS_OVERLAPPEDWINDOW EQU WS_OVERLAPPED OR WS_CAPTION OR WS_SYSMENU OR WS_THICKFRAME OR WS_MINIMIZEBOX OR WS_MAXIMIZEBOX OR WS_VISIBLE

WM_LBUTTONDOWN  EQU 0201h
WM_DESTROY      EQU 0002h

WNDCLASS struc
        clsStyle          dd ?   ; class style
        clsLpfnWndProc    dd ?
        clsCbClsExtra     dd ?
        clsCbWndExtra     dd ?
        clsHInstance      dd ?   ; instance handle
        clsHIcon          dd ?   ; class icon handle
        clsHCursor        dd ?   ; class cursor handle
        clsHbrBackground  dd ?   ; class background brush
        clsLpszMenuName   dd ?   ; menu name
        clsLpszClassName  dd ?   ; far ptr to class name
WNDCLASS ends

POINT   struc
    ptX             dd ?
    ptY             dd ?
POINT   ends

MSGSTRUCT struc
    msHWND          dd ?
    msMESSAGE       dd ?
    msWPARAM        dd ?
    msLPARAM        dd ?
    msTIME          dd ?
    msPT            POINT <?>
MSGSTRUCT ends

OPENFILENAME struc
    Size        dd ?
    HOwner      dd ?
    AppHwnd     dd ?
    Filters     dd ?
    CustFilters dd ?
    CstFltSize  dd ?
    CurFilter   dd ?
    CurFileName dd ?
    CurFlNmSize dd ?
    CurFile     dd ?
    CurFlSize   dd ?
    InitialDir  dd ?
    DlgTitle    dd ?
    Flags       dd ?
    FileOffset  dw ?
    ExtOffset   dw ?
    Extension   dd ?
    CustData    dd ?
    HookProc    dd ?
    TmplateRsc  dd ?
OPENFILENAME ends

; The rectangle structure :
RECT    struc
        rcLeft          dd ? ; the left border position (in pixels) from left
        rcTop           dd ? ; the top border position from top
        rcRight         dd ? ; the right border position from left
        rcBottom        dd ? ; the bottom border position from top
RECT    ends

; The Paint Structure : BeginPaint , EndPaint.
PAINTSTRUCT STRUC
    PShdc         dd ?
    PSfErase      dd ?
    PSrcPaint     RECT <?> ; contains the rectangle structure
    PSfRestore    dd ?
    PSfIncUpdate  dd ?
    PSrgbReserved db 32 dup(?) ; was bad defined in windows.inc
PAINTSTRUCT ENDS

.data

lppaint         PAINTSTRUCT <?>
wc              WNDCLASS <?>
msg             MSGSTRUCT <?>
bmpopen         OPENFILENAME <?>
openname        db 513 dup (0)
HDC             dd 0
bmpfilt         db "Bitmap Files (*.BMP)",0h,"*.BMP",0h
                db "All Files (*.*)",0h,"*.*",0h,0h
bmpdefext       db "bmp",0h

AppHWnd         dd 0
NewHWnd         dd 0
filehandle      dd 0
nbbyteread      dd 0
memptr          dd 0

bmpheader       db 14 dup (?)

bmphdle         dd 0
WindowCaption   db "A little Bitmap Viewer done by _HaK_ !!!",0
WndClassName    db "SeeABmp",0


.code

Start:
        push    0h
        call    GetModuleHandleA
        mov     [AppHWnd],eax

        mov     [wc.clsStyle], CS_HREDRAW + CS_VREDRAW + CS_GLOBALCLASS
        mov     [wc.clsLpfnWndProc], offset WndProc
        mov     [wc.clsCbClsExtra], 0
        mov     [wc.clsCbWndExtra], 0
        mov     eax, [AppHWnd]
        mov     [wc.clsHInstance], eax
        push    32516
        push    0
        call    LoadIconA
        mov     [wc.clsHIcon], eax
        push    32512
        push    0
        call    LoadCursorA
        mov     [wc.clsHCursor], eax
        mov     [wc.clsHbrBackground], COLOR_WINDOW + 1
        mov     dword ptr [wc.clsLpszMenuName], 0
        mov     dword ptr [wc.clsLpszClassName], offset WndClassName
        push    offset wc
        call    RegisterClassA

        push    0                      ; lpParam
        push    [AppHWnd]              ; hInstance
        push    0                      ; menu
        push    0                      ; parent hwnd
        push    CW_USEDEFAULT          ; height
        push    CW_USEDEFAULT          ; width
        push    CW_USEDEFAULT          ; y
        push    CW_USEDEFAULT          ; x
        push    WS_OVERLAPPEDWINDOW    ; Style
        push    offset WindowCaption   ; Title string
        push    offset WndClassName    ; Class name
        push    0                      ; extra style
        call    CreateWindowExA
        mov     [NewHWnd], eax

msg_loop:
        push    0
        push    0
        push    0
        push    offset msg
        call    GetMessageA

        cmp     ax, 0
        je      end_loop

        push    offset msg
        call    TranslateMessage

        push    offset msg
        call    DispatchMessageA

        jmp     msg_loop

end_loop:
        push    0h
        call    ExitProcess


WndProc          proc uses ebx edi esi, hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
        cmp     [wmsg],0fh      ; WM_PAINT ?
        je      repaintwin      
        cmp     [wmsg], WM_DESTROY
        je      wmdestroy
        cmp     [wmsg], WM_LBUTTONDOWN
        je      wmlbuttondown
        push    [lparam]
        push    [wparam]
        push    [wmsg]
        push    [hwnd]
        call    DefWindowProcA
        ret
repaintwin:                     ; WM_PAINT : recquired by all the drawing (else display nothing)
        push    offset lppaint
        push    [hwnd]          ; window handle
        call    BeginPaint      ; Initialize all painting
        push    offset lppaint
        push    [hwnd]
        call    EndPaint        ; finish painting
        xor     eax,eax
        ret
wmdestroy:
        push    0
        call    PostQuitMessage
        mov     eax, 0
        ret
wmlbuttondown:
        mov     [bmpopen.Size],76
        mov     eax,[NewHWnd]
        mov     ebx,[AppHWnd]
        mov     [bmpopen.HOwner],eax
        mov     [bmpopen.AppHwnd],ebx
        mov     [bmpopen.Filters],offset bmpfilt
        mov     [bmpopen.CustFilters],0
        mov     [bmpopen.CstFltSize],0
        mov     [bmpopen.CurFilter],1
        mov     [bmpopen.CurFileName],offset openname
        mov     [bmpopen.CurFlNmSize],512
        mov     [bmpopen.CurFile],0
        mov     [bmpopen.CurFlSize],0
        mov     [bmpopen.InitialDir],0
        mov     [bmpopen.DlgTitle],0
        mov     [bmpopen.Flags],1800h
        mov     [bmpopen.FileOffset],0
        mov     [bmpopen.ExtOffset],0
        mov     [bmpopen.Extension],offset bmpdefext
        mov     [bmpopen.CustData],0
        mov     [bmpopen.HookProc],0
        mov     [bmpopen.TmplateRsc],0
        push    offset bmpopen
        call    GetOpenFileNameA
        push    0
        push    80h
        push    3
        push    0
        push    0
        push    80000000h
        push    offset openname
        call    CreateFileA
        cmp     eax,-1
        jz      couldntopen
        mov     [filehandle],eax
        push    0
        push    offset nbbyteread
        push    14
        push    offset bmpheader
        push    eax
        call    ReadFile
        cmp     [nbbyteread],14
        jnz     Notabitmap
        cmp     word ptr [bmpheader],"MB"
        jnz     Notabitmap
        push    dword ptr [bmpheader+2]
        push    0
        call    GlobalAlloc
        or      eax,eax
        jz      Notabitmap
        mov     [memptr],eax
        push    0
        push    0
        push    0
        push    [filehandle]
        call    SetFilePointer
        push    0
        push    offset nbbyteread
        push    dword ptr [bmpheader+2]
        push    [memptr]
        push    [filehandle]
        call    ReadFile
        mov     esi,[memptr]
        mov     edi,[memptr]
        add     esi,dword ptr [bmpheader+10]
        add     edi,14
        push    [hwnd]
        call    GetDC
        mov     [HDC],eax
        push    0
        push    edi
        push    esi
        push    4
        push    edi
        push    eax
        call    CreateDIBitmap
        mov     [bmphdle],eax
        push    [HDC]
        call    CreateCompatibleDC
        mov     edi,eax
        push    [bmphdle]
        push    eax
        call    SelectObject
        push    205h
        push    0
        push    0
        push    [hwnd]
        Call    RedrawWindow
        push    0cc0020h
        push    0
        push    0
        push    edi
        push    dword ptr [memptr+16h]
        push    dword ptr [memptr+12h]
        push    0
        push    0
        push    [HDC]
        call    BitBlt
        push    [HDC]
        push    [hwnd]
        call    ReleaseDC
        push    [memptr]
        call    GlobalFree
Notabitmap:
        push    [filehandle]
        call    CloseHandle
couldntopen:
        xor     eax,eax
        ret

WndProc          endp

End Start
