dataseg

PSHeader	PROPSHEETHEADER <size PROPSHEETHEADER, PSH_NOAPPLYNOW +\
			PSH_PROPTITLE + PSH_PROPSHEETPAGE, 0, 0, 0,\
			O sz3DFun, 6, 5, O PSPages, 0>
PSPages 	PROPSHEETPAGE <size PROPSHEETPAGE, PSP_DEFAULT +\
			PSP_HIDEHEADER, 0, 101, 0, 0, O PSDialog1, 0, 0, 0>
		PROPSHEETPAGE <size PROPSHEETPAGE, PSP_DEFAULT +\
			PSP_HIDEHEADER, 0, 102, 0, 0, O PSDialog2, 0, 0, 0>
		PROPSHEETPAGE <size PROPSHEETPAGE, PSP_DEFAULT +\
			PSP_HIDEHEADER, 0, 103, 0, 0, O PSDialog3, 0, 0, 0>
		PROPSHEETPAGE <size PROPSHEETPAGE, PSP_DEFAULT +\
			PSP_HIDEHEADER, 0, 104, 0, 0, O PSDialog4, 0, 0, 0>
		PROPSHEETPAGE <size PROPSHEETPAGE, PSP_DEFAULT +\
			PSP_HIDEHEADER, 0, 105, 0, 0, O PSDialog5, 0, 0, 0>
		PROPSHEETPAGE <size PROPSHEETPAGE, PSP_DEFAULT +\
			PSP_HIDEHEADER, 0, 106, 0, 0, O PSDialog6, 0, 0, 0>

Brush		LOGBRUSH <0,0,0>
_ChooseColor	CHOOSECOLOR <size CHOOSECOLOR, ?, 0, ?, O CustColors,\
			CC_RGBINIT + CC_FULLOPEN, 0, 0, 0>
CustColors	dd 16 dup (0)
_ChooseFont	CHOOSEFONT <size CHOOSEFONT, ?, 0, O _LogFont, ?, CF_EFFECTS +\
			CF_FORCEFONTEXIST + CF_INITTOLOGFONTSTRUCT +\
			CF_SCREENFONTS, 0, 0, 0, 0, 0, 0, 0, ?, 0, 0>

udataseg

_LogFont	LOGFONT ?
DlgFriendlySyntax db ?
hBrush1 	dd ?
hBrush2 	dd ?
hBrush3 	dd ?
Color1		dd ?
Color2		dd ?
Color3		dd ?

label DlgVars
DlgXMid 	dd ?
DlgYMid 	dd ?
DlgZMid 	dd ?
DlgXYZScale	dd ?
DlgPGran	dd ?
DlgQGran	dd ?
DlgTMax 	dd ?
DlgPMin 	dt ?
DlgPMax 	dt ?
DlgQMin 	dt ?
DlgQMax 	dt ?

DlgAlphaSpeed	dd ?
DlgBetaSpeed	dd ?
DlgTimeSpeed	dd ?

label DlgBuffers
DlgOpersSize		dd ?
DlgFnBufferSize 	dd ?
DlgBreakTableSize	dd ?
DlgExecBufferSize	dd ?
DlgNumTableSize 	dd ?
DlgExecStackSize	dd ?

codeseg

proc	PSDialog1 uses ebx esi edi, hwnd, uMsg, wParam, lParam
	xor	ecx, ecx
	mov	eax, [uMsg]
	cmp	eax, WM_CTLCOLORSTATIC
	jz	dlg1_color
	cmp	eax, WM_COMMAND
	jz	dlg1_command
	cmp	eax, WM_NOTIFY
	jz	dlg1_notify
dlg1_ok:
	xor	eax, eax
	ret

dlg1_notify:
	mov	eax, [lParam]
	cmp	[(NMHDR eax).code], PSN_SETACTIVE
	jnz	dlg1_ok
	mov	[PSHeader.nStartPage], ecx
	jmp	dlg1_ok

dlg1_color:
	call	GetDlgCtrlID, [lParam]
	sub	eax, 301
	cmp	eax, 2
	ja	dlg1_ok
	mov	eax, [hBrush1+eax*4]
	ret

dlg1_command:
	mov	ebx, [wParam]
	sub	ebx, 304
	cmp	ebx, 2
	ja	dlg1_ok
	lea	edi, [Color1+ebx*4]
	mov	eax, [edi]
	mov	[dword _ChooseColor.rgbResult], eax
	mov	eax, [hwnd]
	mov	[_ChooseColor.hwndOwner], eax
	call	ChooseColor, O _ChooseColor
	or	eax, eax
	jz	dlg1_ok
	mov	eax, [dword _ChooseColor.rgbResult]
	mov	[edi], eax
	lea	esi, [hBrush1+ebx*4]
	call	DeleteObject, [dword esi]
	mov	eax, [edi]
	mov	[dword Brush.lbColor], eax
	call	CreateBrushIndirect, O Brush
	mov	[esi], eax
	call	InvalidateRect, [hwnd], 0, 1
	jmp	dlg1_ok
endp

proc	PSDialog2 uses ebx esi edi, hwnd, uMsg, wParam, lParam
	mov	ecx, 1
	mov	eax, [uMsg]
	cmp	eax, WM_NOTIFY
	jz	dlg1_notify
	cmp	eax, WM_COMMAND
	jz	dlg2_command
	cmp	eax, WM_INITDIALOG
	jnz	dlg2_ok
	movzx	eax, [DlgFriendlySyntax]
	call	SendDlgItemMessage, [hwnd], 303, BM_SETCHECK, eax, 0
dlg2_setface:
	call	SetDlgItemText, [hwnd], 301, O _LogFont.lfFaceName
	jmp	dlg2_ok
dlg2_command:
	mov	eax, [wParam]
	cmp	eax, 303
	jnz	dlg2_1
	call	SendDlgItemMessage, [hwnd], 303, BM_GETCHECK, 0, 0
	and	al, 1
	mov	[DlgFriendlySyntax], al
	jmp	dlg2_ok
dlg2_1: cmp	eax, 302
	jnz	dlg2_ok
	mov	eax, [hwnd]
	mov	[_ChooseFont.hwndOwner], eax
	call	ChooseFont, O _ChooseFont
	or	eax, eax
	jnz	dlg2_setface
dlg2_ok:
	xor	eax, eax
	ret
endp

proc	PSDialog3 uses ebx esi edi, hwnd, uMsg, wParam, lParam
	mov	ecx, 2
	mov	eax, [uMsg]
	cmp	eax, WM_NOTIFY
	jz	dlg1_notify
	cmp	eax, WM_COMMAND
	jz	dlg3_command
	cmp	eax, WM_INITDIALOG
	jnz	dlg3_ok
	mov	esi, O DlgVars
	mov	edi, 301
	mov	bl, 4
dlg3_1: push	-7
	fild	[dword esp]
	pop	eax
	fild	[dword esi]
	add	esi, 4
	fscale
	fstp	st(1)
	call	NumToStr
	call	SetDlgItemText, [hwnd], edi, eax
	inc	edi
	dec	bl
	jnz	dlg3_1
	mov	esi, O DlgPMin
	mov	bl, 4
dlg3_2: fld	[tbyte esi]
	add	esi, 10
	call	NumToStr
	call	SetDlgItemText, [hwnd], edi, eax
	inc	edi
	dec	bl
	jnz	dlg3_2
	mov	esi, O DlgPGran
	mov	bl, 3
dlg3_3: call	SetDlgItemInt, [hwnd], edi, [dword esi], 0
	add	esi, 4
	inc	edi
	dec	bl
	jnz	dlg3_3
	jmp	dlg3_ok
dlg3_command:
	movzx	eax, [word wParam+2]
	cmp	eax, EN_CHANGE
	jnz	dlg3_ok
	movzx	eax, [word wParam]
	lea	edi, [eax-301]
	cmp	edi, 7
	ja	dlg3_4
	call	StrToNum
	jc	dlg3_ok
	cmp	edi, 4
	jc	dlg3_8
	sub	edi, 4
	imul	edi, 10
	lea	edi, [DlgPMin+edi]
	fstp	[tbyte edi]
	jmp	dlg3_ok
dlg3_8: lea	edi, [DlgXMid+edi*4]
	push	7
	fild	[dword esp]
	add	esp, 4
	fxch	st(1)
	fscale
	fstp	st(1)
	fistp	[dword edi]
	jmp	dlg3_ok
dlg3_4: push	eax
	mov	ecx, esp
	call	GetDlgItemInt, [hwnd], eax, ecx, 0
	pop	ecx
	or	ecx, ecx
	jz	dlg3_ok
	xor	ecx, ecx
	mov	edx, 80000000h
	cmp	edi, 10
	jz	dlg3_5
	inc	ecx
	inc	ecx
	mov	edx, 200
dlg3_5: cmp	eax, ecx
	jnc	dlg3_6
	mov	eax, ecx
dlg3_6: cmp	eax, edx
	jna	dlg3_7
	mov	eax, edx
dlg3_7: mov	[DlgPGran+edi*4-32], eax
dlg3_ok:
	xor	eax, eax
	ret
endp

proc	PSDialog4 uses ebx esi edi, hwnd, uMsg, wParam, lParam
	mov	ecx, 3
	mov	eax, [uMsg]
	cmp	eax, WM_NOTIFY
	jz	dlg1_notify
	cmp	eax, WM_COMMAND
	jz	dlg4_command
	cmp	eax, WM_INITDIALOG
	jnz	dlg4_ok
	mov	esi, O DlgBuffers
	mov	edi, 301
	mov	bl, 6
dlg4_x: call	SetDlgItemInt, [hwnd], edi, [dword esi], 0
	add	esi, 4
	inc	edi
	dec	bl
	jnz	dlg4_x
	jmp	dlg4_ok
dlg4_command:
	movzx	eax, [word wParam+2]
	cmp	eax, EN_CHANGE
	jnz	dlg4_ok
	movzx	eax, [word wParam]
	mov	edi, eax
	sub	edi, 301
	shl	edi, 2
	push	eax
	mov	ecx, esp
	call	GetDlgItemInt, [hwnd], eax, ecx, 0
	pop	ecx
	or	ecx, ecx
	jz	dlg4_ok
	cmp	eax, 1024
	jnc	dlg4_2
	mov	eax, 1024
dlg4_2: cmp	eax, 65536
	jna	dlg4_3
	mov	eax, 65536
dlg4_3: mov	[DlgBuffers+edi], eax
dlg4_ok:
	xor	eax, eax
	ret
endp

proc	PSDialog5 uses ebx esi edi, hwnd, uMsg, wParam, lParam
	mov	ecx, 4
	mov	eax, [uMsg]
	cmp	eax, WM_NOTIFY
	jz	dlg1_notify
	cmp	eax, WM_HSCROLL
	jz	dlg5_hscroll
	cmp	eax, WM_INITDIALOG
	jnz	dlg5_ok
	mov	ebx, [hwnd]
	mov	edi, 301
	mov	esi, O DlgAlphaSpeed
	mov	eax, (21 shl 16)-20
	push	eax
	call	SetTrackbar
	pop	eax
	call	SetTrackbar
	mov	eax, 20 shl 16 + 1
	call	SetTrackbar
	jmp	dlg5_ok
dlg5_hscroll:
	call	GetDlgCtrlID, [lParam]
	push	eax
	call	SendMessage, [lParam], TBM_GETPOS, 0, 0
	pop	edx
	mov	ecx, edx
	sub	ecx, 301
	mov	[DlgAlphaSpeed+ecx*2], eax
	inc	edx
	call	SetDlgItemInt, [hwnd], edx, eax, 1
dlg5_ok:
	xor	eax, eax
	ret
endp

proc	SetTrackbar
	call	SendDlgItemMessage, ebx, edi, TBM_SETRANGE, 1, eax
	call	SendDlgItemMessage, ebx, edi, TBM_SETTICFREQ, 4, 0
	call	SendDlgItemMessage, ebx, edi, TBM_SETPOS, 1, [dword esi]
	inc	edi
	call	SetDlgItemInt, ebx, edi, [dword esi], 1
	inc	edi
	add	esi, 4
	ret
endp

proc	PSDialog6 uses ebx, hwnd, uMsg, wParam, lParam
	cmp	[uMsg], WM_NOTIFY
	jnz	dlg6_ok
	mov	eax, [lParam]
	cmp	[(NMHDR eax).code], PSN_SETACTIVE
	jnz	dlg6_ok
	mov	[byte PSHeader.nStartPage], 5
	mov	ebx, [PGran]
	imul	ebx, [QGran]
	add	ebx, NUMGRIDPOINTS
	call	SetDlgItemInt, [hwnd], 301, ebx, 0
	lea	ebx, [ebx+ebx*2]
	shl	ebx, 3
	add	ebx, [DlgOpersSize]
	add	ebx, [DlgFnBufferSize]
	add	ebx, [DlgBreakTableSize]
	add	ebx, [DlgExecBufferSize]
	add	ebx, [DlgNumTableSize]
	add	ebx, [DlgExecStackSize]
	add	ebx, [BmpInfo.biSizeImage]
	call	SetDlgItemInt, [hwnd], 302, ebx, 0
dlg6_ok:
	xor	eax, eax
	ret
endp

proc	Properties
	mov	ecx, 6
	mov	edx, O (PROPSHEETPAGE PSPages).hInstance
	mov	eax, [hInstance]
prp_01: mov	[edx], eax
	add	edx, 40
	loop	prp_01

	mov	esi, O DefVars
	mov	edi, O DlgVars
	call	MoveVars
	mov	esi, O Buffers
	mov	edi, O DlgBuffers
	mov	ecx, 6
	rep	movsd
	mov	esi, O AlphaSpeed
	mov	edi, O DlgAlphaSpeed
	movsd
	movsd
	movsd

	mov	esi, O BackgroundColor
	mov	edi, O hBrush1
	mov	edx, O Color1
	mov	bl, 3
prp_03: lodsd
	xchg	al, ah
	rol	eax, 16
	xchg	al, ah
	shr	eax, 8
	mov	[edx], eax
	add	edx, 4
	mov	[dword Brush.lbColor], eax
	push	edx
	call	CreateBrushIndirect, O Brush
	pop	edx
	stosd
	dec	bl
	jnz	prp_03

	mov	esi, O FontStruc
	mov	edi, O _LogFont
	mov	ecx, size LOGFONT
	rep	movsb
	mov	al, [FriendlySyntax]
	mov	[DlgFriendlySyntax], al

	mov	eax, [hwnd]
	mov	[PSHeader.hwndParent], eax
	call	PropertySheet, O PSHeader

	push	eax
	mov	esi, O hBrush1
	mov	bl, 3
prp_04: lodsd
	call	DeleteObject, eax
	dec	bl
	jnz	prp_04
	pop	eax

	cmp	eax, 1
	jnz	prp_02

	mov	al, [DlgFriendlySyntax]
	mov	[FriendlySyntax], al
	mov	esi, O _LogFont
	mov	edi, O FontStruc
	mov	ecx, size LOGFONT
	rep	movsb
	call	DeleteObject, [hEditFont]
	call	CreateFontIndirect, O FontStruc
	mov	[hEditFont], eax
	call	SendMessage, [hwndFormula], WM_SETFONT, eax, 0

	mov	esi, O Color1
	mov	edi, O BackgroundColor
	mov	ecx, 3
prp_05: lodsd
	xchg	al, ah
	rol	eax, 16
	xchg	al, ah
	shr	eax, 8
	stosd
	loop	prp_05

	mov	esi, O DlgVars
	mov	edi, O DefVars
	call	MoveVars
	mov	esi, O DlgBuffers
	mov	edi, O Buffers
	mov	ecx, 6
	rep	movsd
	mov	esi, O DlgAlphaSpeed
	mov	edi, O AlphaSpeed
	movsd
	movsd
	movsd
	cmp	[CurrentTab], 0
	jnz	prp_06
	call	[CalcChart]
	call	UpdateChart
	call	SetupTimeScroll
	call	InvalidateRect, [hwndChart], 0, 1
	jmp	prp_02
prp_06: call	InvalidateRect, [hwndFormula], 0, 1
prp_02: ret
endp

proc	NumToStr uses ebx esi edi
	sub	esp, 10
	fld	st
	push	eax
	fstcw	[word esp]
	pop	eax
	or	ah, 0Ch
	push	eax
	fldcw	[word esp]
	pop	eax
	frndint
	fsub	st(1), st
	fbstp	[tbyte esp]
	lea	esi, [esp+9]
	mov	edi, O TempText
	mov	al, [esi]
	dec	esi
	mov	ecx, 19
	cld
	test	al, 80h
	jz	nts_1
	mov	al, '-'
	stosb
	dec	ecx
nts_1:	call	_StNum
	mov	al, '.'
	stosb
	call	tentox, ecx
	fmulp	st(1), st
	fbstp	[tbyte esp]
	lea	esi, [esp+8]
	call	_StNum
	add	esp, 10
nts_6:	dec	edi
	mov	al, [edi]
	cmp	al, '0'
	jz	nts_6
	cmp	al, '.'
	jz	nts_7
	inc	edi
nts_7:	mov	[byte edi], 0
	mov	eax, O TempText
	ret
endp

proc	_StNum
	mov	ch, 10
nts_2:	mov	al, [esi]
	dec	esi
	dec	ch
	jz	nts_5
	or	al, al
	jz	nts_2
	test	al, 0F0h
	jz	nts_4
nts_3:	mov	ah, al
	shr	al, 4
	and	ah, 0Fh
	add	al, '0'
	stosb
	dec	cl
	mov	al, ah
nts_4:	add	al, '0'
	stosb
	dec	cl
	mov	al, [esi]
	dec	esi
	dec	ch
	jnz	nts_3
	ret
nts_5:	mov	al, '0'
	stosb
	dec	ecx
	ret
endp

proc	StrToNum uses ecx edx esi edi
	fninit
	mov	esi, O TempText
	call	GetDlgItemText, [hwnd], eax, esi, 20
	cmp	[byte esi], '-'
	setz	ah
	jnz	lb_81
	inc	esi
lb_81:	mov	edi, esi
	mov	al, 0
	mov	ecx, -1
	cld
	repnz	scasb
	not	ecx
	dec	ecx
	mov	edx, ecx
	mov	al, '.'
	mov	edi, esi
	repnz	scasb
	jnz	lb_82
	not	ecx
	add	ecx, edx
	sub	edx, ecx
	dec	edx
	jmp	lb_83
lb_82:	xchg	ecx, edx
lb_83:	call	_LdNum
	jc	lb_86
	lea	esi, [esi+ecx+1]
	mov	ecx, edx
	jecxz	lb_84
	call	tentox, edx
	call	_LdNum
	jc	lb_86
	fdivrp	st(1), st
	faddp	st(1), st
lb_84:	cmp	ah, 0
	jz	lb_85
	fchs
lb_85:	clc
lb_86:	ret
endp

proc	_LdNum uses eax ecx edx esi
	sub	esp, 10
	cmp	ecx, 18
	ja	lb_89
	mov	edx, ecx
	mov	ecx, 10
	mov	edi, esp
	mov	al, 0
	rep	stosb
	mov	edi, esp
	lea	esi, [esi+edx-1]
	mov	cl, 0
lb_87:	mov	al, [esi]
	dec	esi
	sub	al, '0'
	cmp	al, 9
	ja	lb_89
	shl	al, cl
	or	[edi], al
	xor	cl, 4
	jnz	lb_88
	inc	edi
lb_88:	dec	edx
	jnz	lb_87
	fbld	[tbyte esp]
	clc
	add	esp, 10
	clc
	ret
lb_89:	add	esp, 10
	fninit
	stc
	ret
endp

proc	tentox uses eax ecx, __X
	fild	[__X]
	fldl2t
	fmulp	st(1), st
	call	f2x
	ret
endp
