proc	StdCalcChart uses ebp
pstep	= tbyte esp
qstep	= tbyte esp + 10
	call	GlobalLock, [hmem3DPoints]

	mov	esi, [StdFun]
	sub	esp, 2*10

	dec	[PGran]
	fild	[PGran]
	inc	[PGran]

	fld	[PMax]				; pstep = (pmax-pmin)/(pgran-1)
	fld	[PMin]
	fsubp	st(1), st
	fdiv	st, st(1)
	fstp	[pstep]
	ffree	st

	dec	[QGran]
	fild	[QGran]
	inc	[QGran]

	fld	[QMax]				; qstep = (qmax-qmin)/(qgran-1)
	fld	[QMin]
	fsubp	st(1), st
	fdivrp	st(1), st
	fstp	[qstep]

	mov	ebx, [XMid]			; hx = xmid
	mov	edi, [YMid]			; hy = ymid
	mov	ebp, [ZMid]			; hz = zmid

	push	7
	fild	[dword esp]
	add	esp, 4
	mov	edx, [QGran]
	fld	[QMin]
cfn_1:	mov	ecx, [PGran]
	fld	[PMin]
cfn_2:	fxch	st(2)
	fld	st(2)
	fscale
	fistp	[dword eax]
	sub	[eax], ebx
	add	eax, 4
	fld	st(1)
	fscale
	fistp	[dword eax]
	sub	[eax], edi
	add	eax, 4
	fld	st(1)
	fld	st(3)
	call	esi
	fscale
	fistp	[dword eax]
	sub	[eax], ebp
	add	eax, 4
	fxch	st(2)
	fld	[pstep]
	faddp	st(1), st
	loop	cfn_2
	ffree	st
	fincstp
	fld	[qstep]
	faddp	st(1), st
	dec	edx
	jnz	cfn_1

	ffree	st
	fincstp
	ffree	st

	add	esp, 2*10
	call	GlobalUnlock, [hmem3DPoints]
	ret
endp

proc	Bridge
	fmul	st, st
	push	9
	fiadd	[dword esp]
	mov	[dword esp], 18d
	fidivr	[dword esp]
	fxch	st(1)
	fld	st
	fmul	st, st
	mov	[dword esp], 10d
	fiadd	[dword esp]
	fxch	st(1)
	mov	[dword esp], 6
	fimul	[dword esp]
	fld	st(1)
	fadd	st, st(1)
	mov	[dword esp], 4
	fidivr	[dword esp]
	faddp	st(3), st
	fsubp	st(1), st
	fidivr	[dword esp]
	faddp	st(1), st
	add	esp, 4
	ret
endp

proc	Sine3D
	fmul	st, st
	fxch	st(1)
	fmul	st, st
	faddp	st(1), st
	fsqrt
	fsin
	fld1
	fxch	st(1)
	fscale
	fstp	st(1)
	ret
endp

proc	ArcusTangent
	fld1
	fpatan
	fxch	st(1)
	fld1
	fpatan
	faddp	st(1), st
	push	3
	fimul	[dword esp]
	add	esp, 4
	ret
endp
