;Obtained using MASM's h2ash32 utility on math.h, plus additional editing
 
; Had warning that macro definitions 49,50 and 284 (in source) are ignored 

__MATH_H            EQU     1h

___DEFS_H           EQU     1h

_RTLENTRY           EQU     <__cdecl>

_USERENTRY          EQU     <__cdecl>

_RTLENTRYF          EQU     <_RTLENTRY>

_FAR                EQU     1h

_EXPCLASS           EQU     1h

_EXPDATA            EQU     1h

_EXPFUNC            EQU     1h

_EXPFUNC32          EQU     <_EXPFUNC>

_EXPFUNC16          EQU     1h

_Cdecl              EQU     <_RTLENTRY>

_CType              EQU     <_RTLENTRYF>

_CLASSTYPE          EQU     <_EXPCLASS>

_FARFUNC            EQU     <_EXPFUNC>

_FARCALL            EQU     <_EXPFUNC __far>

complex             STRUC   
x                   DQ      ?
y                   DQ      ?
complex             ENDS

_complexl           STRUC   
x                   DT      ?
y                   DT      ?
_complexl           ENDS

;tag$0               ENUM    {	;ENUM operator is not supported in MASM	
;                    DOMAIN=1,
;                    SING,
;                    OVERFLOW,
;                    UNDERFLOW,
;                    TLOSS,
;                    PLOSS,
;                    STACKFAULT,
;                    pad$0=256}

;_mexcep             TYPEDEF tag$0	; tag$0 undefined

M_E                 EQU     <2.71828182845904523536>
M_LOG2E             EQU     <1.44269504088896340736>
M_LOG10E            EQU     <0.434294481903251827651>
M_LN2               EQU     <0.693147180559945309417>
M_LN10              EQU     <2.30258509299404568402>
M_PI                EQU     <3.14159265358979323846>
M_PI_2              EQU     <1.57079632679489661923>
M_PI_4              EQU     <0.785398163397448309616>
M_1_PI              EQU     <0.318309886183790671538>
M_2_PI              EQU     <0.636619772367581343076>
M_1_SQRTPI          EQU     <0.564189583547756286948>
M_2_SQRTPI          EQU     <1.12837916709551257390>
M_SQRT2             EQU     <1.41421356237309504880>
M_SQRT_2            EQU     <0.707106781186547524401>
EDOM                EQU     33
ERANGE              EQU     34

exception           STRUC   
etype               DW      ?		;Changed name from type to etype to avoid clash
name                DW      NEAR PTR ?
arg1                DQ      ?
arg2                DQ      ?
retval              DQ      ?
exception           ENDS

_exceptionl         STRUC   
etype               DW      ?
name                DW      NEAR PTR ?
arg1                DT      ?
arg2                DT      ?
retval              DT      ?
_exceptionl         ENDS

HUGE_VAL            EQU     <_huge_dble>

;EXTRN            _huge_dble          :QWORD 

_LHUGE_VAL          EQU     <_huge_ldble>

;EXTRN            _huge_ldble         :TBYTE 

acos	PROTO	STDCALL	arg:QWORD
asin	PROTO	STDCALL	arg:QWORD
atan	PROTO	STDCALL	arg:QWORD
atan2	PROTO	STDCALL	y:QWORD, x:QWORD

ceil	PROTO	STDCALL	num:QWORD
cos	PROTO	STDCALL	arg:QWORD
cosh	PROTO	STDCALL	arg:QWORD
exp	PROTO	STDCALL arg:QWORD

;EXTRN            fabs                :NEAR	;Clashes with F.P instruction

floor	PROTO	STDCALL	num:QWORD
fmod	PROTO	STDCALL	x:QWORD, y:QWORD
frexp	PROTO	STDCALL	num:QWORD,i:DWORD

ldexp	PROTO	STDCALL	num:QWORD, exp:QWORD
log	PROTO	STDCALL	num:QWORD
log10	PROTO	STDCALL num:QWORD
modf	PROTO	STDCALL	num:QWORD, i:QWORD
pow	PROTO	STDCALL	base:QWORD, exp:QWORD

sin	PROTO	STDCALL arg:QWORD
sinh	PROTO	STDCALL arg:QWORD
sqrt	PROTO	STDCALL	num:QWORD
tan	PROTO	STDCALL	arg:QWORD
tanh	PROTO	STDCALL	arg:QWORD

acosl	PROTO	STDCALL arg:TBYTE
asinl   PROTO	STDCALL	arg:TBYTE
atan2l	PROTO	STDCALL y:TBYTE, x:TBYTE
atanl	PROTO	STDCALL	arg:TBYTE
ceill	PROTO	STDCALL	num:TBYTE
coshl	PROTO	STDCALL	arg:TBYTE
cosl	PROTO	STDCALL arg:TBYTE
expl	PROTO	STDCALL	arg:TBYTE
fabsl	PROTO	STDCALL	num:TBYTE
floorl	PROTO	STDCALL	num:TBYTE
fmodl	PROTO	STDCALL	x:TBYTE, y:TBYTE
frexpl	PROTO	STDCALL	num:TBYTE, exp:DWORD
ldexpl	PROTO	STDCALL	num:TBYTE, exp:DWORD
log10l	PROTO	STDCALL	num:TBYTE
logl	PROTO	STDCALL	num:TBYTE
modfl	PROTO	STDCALL	num:TBYTE, i:TBYTE
powl	PROTO	STDCALL	base:TBYTE, exp:TBYTE
sinhl	PROTO	STDCALL	arg:TBYTE
sinl	PROTO	STDCALL	arg:TBYTE
sqrtl	PROTO	STDCALL	num:TBYTE
tanhl	PROTO	STDCALL	arg:TBYTE
tanl	PROTO	STDCALL	arg:TBYTE

;__sin__             :NEAR
;__cos__             :NEAR
;__cosl__            :NEAR
;__sinl__            :NEAR

;__ABS_DEFINED       EQU     1h

;__abs__             :NEAR

abs	PROTO	STDCALL	num:DWORD
atof	PROTO	STDCALL	adr:QWORD
labs	PROTO	STDCALL	num:DWORD
pow10	PROTO	STDCALL	n:DWORD
_atold	PROTO	STDCALL adr:QWORD

;_matherr            :NEAR
;_matherrl           :NEAR

hypot	PROTO	STDCALL	x:QWORD, y:QWORD
poly	PROTO	STDCALL x:QWORD, n:DWORD, cc:QWORD
hypotl	PROTO	STDCALL x:TBYTE, y:TBYTE
polyl	PROTO	STDCALL	x:TBYTE, n:DWORD, cc:TBYTE
pow10l	PROTO	STDCALL	n:DWORD

; end of file "MATH.inc"

