ID_ICON 		= 101
ID_TOOLBARBMP		= 101
ID_CURSOR		= 101

NTOOLBMPS		= 5

ID_TOOLBAR		= 101
ID_NEW			= 102
ID_LOAD 		= 103
ID_SAVE 		= 104
ID_ANIM 		= 105
ID_FUN1 		= 106
ID_FUN2 		= 107
ID_FUN3 		= 108
ID_OPTIONS		= 109
ID_HELP 		= 110

ID_TABCONTROL		= 111
ID_CHART		= 112
ID_FORMULA		= 113
ID_TIMESCROLL		= 114

MINTTID 		= ID_NEW
MAXTTID 		= ID_HELP

SCROLLSIZE		= 17	; time scroll size
MINWINSIZE		= 300	; minimum size of window square

extrn	GetModuleHandle 		: proc	; Kernel functions
extrn	GlobalAlloc			: proc
extrn	GlobalReAlloc			: proc
extrn	GlobalFree			: proc
extrn	GlobalLock			: proc
extrn	GlobalUnlock			: proc
extrn	CreateFile			: proc
extrn	CloseHandle			: proc
extrn	GetFileSize			: proc
extrn	ReadFile			: proc
extrn	WriteFile			: proc
extrn	ExitProcess			: proc

extrn	LoadIcon			: proc	; User functions
extrn	LoadCursor			: proc
extrn	RegisterClass			: proc
extrn	CreateWindowEx			: proc
extrn	ShowWindow			: proc
extrn	UpdateWindow			: proc
extrn	GetMessage			: proc
extrn	TranslateMessage		: proc
extrn	DispatchMessage 		: proc
extrn	PostQuitMessage 		: proc
extrn	DefWindowProc			: proc
extrn	SendMessage			: proc
extrn	GetStockObject			: proc
extrn	GetWindowRect			: proc
extrn	MoveWindow			: proc
extrn	InvalidateRect			: proc
extrn	RedrawWindow			: proc
extrn	BeginPaint			: proc
extrn	EndPaint			: proc
extrn	MessageBox			: proc
extrn	SetDlgItemInt			: proc
extrn	SetDlgItemText			: proc
extrn	GetDlgItemInt			: proc
extrn	GetDlgItemText			: proc
extrn	GetDlgCtrlID			: proc
extrn	SetScrollRange			: proc
extrn	SetScrollPos			: proc
extrn	GetScrollPos			: proc
extrn	SendDlgItemMessage		: proc
extrn	SetCapture			: proc
extrn	ReleaseCapture			: proc
extrn	SetTimer			: proc
extrn	KillTimer			: proc
extrn	GetWindowPlacement		: proc
extrn	WinHelp 			: proc

extrn	GetCurrentObject		: proc	; GDI functions
extrn	SetDIBitsToDevice		: proc
extrn	CreateFontIndirect		: proc
extrn	CreateBrushIndirect		: proc
extrn	DeleteObject			: proc

extrn	CreateToolbarEx 		: proc	; Common Controls functions
extrn	PropertySheet			: proc

extrn	GetOpenFileName 		: proc	; Common Dialogs functions
extrn	GetSaveFileName 		: proc
extrn	ChooseColor			: proc
extrn	ChooseFont			: proc

extrn	RegCreateKeyEx			: proc	; Advanced API
extrn	RegCloseKey			: proc
extrn	RegQueryValueEx 		: proc
extrn	RegSetValueEx			: proc
